//+------------------------------------------------------------------+
//|                                               OnlyPivotV_1.7.mq4 |
//|                                                     David Willis |
//| Indicators needed for this to work:
//|  OnlyPivot_Level_W1F                                                             
//|  BrainTrend1StopLine
//|  BBANDS~1
//|
//+------------------------------------------------------------------+
#property copyright "David Willis"
#property link      ""


extern double  Lots = 0.1;  
extern int     Start_time = 0; // the Hour to start
extern int     endtradingtime=17;
extern int     slippage = 5;
extern int     MagicNumber = 123456;
extern int     buffer=0;
extern bool    useweekly=false;
extern bool    usebrain=false;
extern bool    usebband=false;
extern bool    latentry=true;
extern int     MAMode=2;  //0=sma, 1=ema, 2=smma, 3=lwma
extern int     pricemode=6;  // 0=close, 1=open,2=high,3=low,4=median, 5=typical, 6=weighted 
extern int     enday=23;
extern int     endayfriday=19;

//profit targets
extern double      TP1 = 50;       //first profit target
extern double      TP2 = 110;      //second profit target
extern double      TP3 = 0;        //third profit target
extern double      TP4 = 0;
extern double      TP5 = 0;

//trail stop loss
extern double      trailstop=0;     
extern double      SLinitial=75;   //initial stop loss
extern double      SL1 = -1;
extern double      SL2 = -50;
extern double      SL3 = 0;
extern double      SL4 = 0;
extern double      SL5 = 0;
extern double      SLA1 = 50;     //pips provit to move to first sl
extern double      SLA2 = 100;
extern double      SLA3 = 0; 
extern double      SLA4 = 0;
extern double      SLA5 = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
 int numbertrades=trades();
 double sl,tp1,tp2,tp3,tp4,tp5;
 double daily = Open[openhour()];
 double weekly = iCustom(NULL,0,"OnlyPivot_Level_W1F",0,0);
 double brain1 = iCustom(NULL,0,"BrainTrend1StopLine",0,1);
 double brain2 = iCustom(NULL,0,"BrainTrend1StopLine",1,1);
 double brain;
 double bband1 = iCustom(NULL,0,"BBANDS~1",0,1);
 double bband2 = iCustom(NULL,0,"BBANDS~1",1,1);
 double bband;
   
 if (brain2 == EMPTY_VALUE) {brain=brain1;}
 else {brain=brain2;}

 if (bband2 == EMPTY_VALUE) {bband=bband1;}
 else {bband=bband2;}
   
   
   
 Comment("daily = ",daily,"\nmoving average ",iMA(Symbol(),0,2,0,MAMode,pricemode,0),
 "\ntradedirection = ",tradedirection(),"\nopentrades= ",opentrades());


 

// Take care of open trades
 if(opentrades()>0)
 {
  //close at end of day
  if(endofday()>0) 
  {
   closealltrades();
   return(0);
  } 
 
 
  modifystoploss();
     
   
      
  //close if ma cross
   
   
  if(useweekly==false)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-buffer*Point && Minute()==0 && tradedirection()==1)
   {closealltrades();}
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+buffer*Point && Minute()==0 && tradedirection()==0)
   {closealltrades();}
  }
  else
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,1) < weekly-buffer*Point && Minute()==0 && tradedirection()==1)
   {closealltrades();}
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,1) > weekly-buffer*Point && Minute()==0 && tradedirection()==0)
   {closealltrades();}
  }
  
 }
     
   
 // No open trades, or not all trades open   
   
 if(tradingtime()>0 && opentrades()<trades()) 
 {
  //Start of day
  if(Hour()==Start_time+1 && Minute()==0)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+buffer*Point)
   {
    if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > weekly-buffer*Point || useweekly==false)
    {
     if(brain<Open[1] || usebrain==false)
     {
      if(bband<Open[1] || usebband==false)
      {
      sl=Ask-SLinitial*Point;
      tp1=Ask+TP1*Point;
      tp2=Ask+TP2*Point;
      tp3=Ask+TP3*Point;
      tp4=Ask+TP4*Point;
      tp5=Ask+TP5*Point;
      if (opentrades()==0)
      {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
      if(opentrades()<=1 && numbertrades>1)
      {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
      if(opentrades()<=2 && numbertrades>2)
      {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
      if(opentrades()<=3 && numbertrades>3)
      {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
      if(opentrades()<=4 && numbertrades>4)
      {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
     }}
    }
   }
          
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-buffer*Point) 
   {
    if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < weekly-buffer*Point || useweekly==false)
    {
     if(brain>Open[1] || usebrain==false)
     {
      if(bband>Open[1] || usebband==false)
      {
      sl=Bid+SLinitial*Point;
      tp1=Bid-TP1*Point;
      tp2=Bid-TP2*Point;
      tp3=Bid-TP3*Point;
      tp4=Bid-TP4*Point;
      tp5=Bid-TP5*Point;
      if(opentrades()==0)
      {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
      if(opentrades()<=1 && numbertrades>1)
      {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
      if(opentrades()<=2 && numbertrades>2)
      {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
      if(opentrades()<=3 && numbertrades>3)
      {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
      if(opentrades()<=4 && numbertrades>4)
      {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
     }}
    }
   }
  }
 }       
 // 2wma cross 
 if (tradingtime()>0 && opentrades()< trades() && Minute()==0)
 {
  if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,2) < daily+buffer*Point)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > weekly+buffer*Point || useweekly==false)
   {
    if(brain < Open[1] || usebrain==false)
    {
     if(bband < Open[1] || usebband==false)
     {
     sl=Ask-SLinitial*Point;
     tp1=Ask+TP1*Point;
     tp2=Ask+TP2*Point;
     tp3=Ask+TP3*Point;
     tp4=Ask+TP4*Point;
     tp5=Ask+TP5*Point;
     if (opentrades()==0)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=1 && numbertrades>1)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=2 && numbertrades>2)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=3 && numbertrades>3)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=4 && numbertrades>4)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
    }}
   }
  } 
  if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,2) > daily-buffer*Point)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < weekly-buffer*Point || useweekly==false)
   {
    if(brain>Open[1] || usebrain==false)
    {
     if(bband>Open[1] || usebband==false)
     {
     sl=Bid+SLinitial*Point;
     tp1=Bid-TP1*Point;
     tp2=Bid-TP2*Point;
     tp3=Bid-TP3*Point;
     tp4=Bid-TP4*Point;
     tp5=Bid-TP5*Point;
     if(opentrades()==0)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=1 && numbertrades>1)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=2 && numbertrades>2)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=3 && numbertrades>3)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=4 && numbertrades>4)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
    }}
   }
  }
 }
     
        
 //late entry because of filter
 if(lastentry()==0 && latentry==true && opentrades()< trades() && tradingtime()>0 && Minute()==0)
 {
  
  if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-buffer*Point)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < weekly-buffer*Point || useweekly==false)
   {
    if(brain > Bid || usebrain==false)
    {
     if(bband > Bid || usebband==false)
     {
     sl=Bid+SLinitial*Point;
     tp1=Bid-TP1*Point;
     tp2=Bid-TP2*Point;
     tp3=Bid-TP3*Point;
     tp4=Bid-TP4*Point;
     tp5=Bid-TP5*Point;
     if(opentrades()==0)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=1 && numbertrades>1)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=2 && numbertrades>2)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=3 && numbertrades>3)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
     if(opentrades()<=4 && numbertrades>4)
     {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
    }}
   }
  }
  if (iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+buffer*Point)
  {
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > weekly-buffer*Point || useweekly==false)
   {
    if(brain < Bid || usebrain==false)
    {
     if(bband < Bid || usebband==false)
     {
     sl=Ask-SLinitial*Point;
     tp1=Ask+TP1*Point;
     tp2=Ask+TP2*Point;
     tp3=Ask+TP3*Point;
     tp4=Ask+TP4*Point;
     tp5=Ask+TP5*Point;
     if (opentrades()==0)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=1 && numbertrades>1)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=2 && numbertrades>2)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=3 && numbertrades>3)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
     if(opentrades()<=4 && numbertrades>4)
     {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
    }}
   }
  }
 }
 return(0); 
}
    
  
//+------------------------------------------------------------------+

int lastcross()
{

  int cnt,bars;
  int cross=25;
  
  for(cnt=Start_time;cnt!= Hour();cnt++)
  {
   if(cnt==24){cnt=0;}
   if(Hour()>cnt){bars=Hour()-cnt;}
   else {bars=24-(cnt-Hour());}
   if(cnt==Start_time){cross=bars;}
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,bars) > Open[openhour()]+buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,bars+1) < Open[openhour()])
   {cross=bars;}
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,bars) < Open[openhour()]+buffer*Point && iMA(Symbol(),0,2,0,MAMode,pricemode,bars+1) > Open[openhour()])
   {cross=bars;}
  }
  return(cross);
}


int lastentry()
{

 int cnt,bars;
 int entry=lastcross()+1;
 double daily = Open[openhour()];
 double weekly = iCustom(NULL,0,"OnlyPivot_Level_W1F",0,0);
 double brain1,brain2,brain;
 double bband1,bband2,bband; 
    
  
 //long
 if(iMA(Symbol(),0,2,0,MAMode,pricemode,lastcross()) > daily+buffer*Point)
 {
  for(cnt=lastcross()-1;cnt>=0;cnt--)
  {
   brain1 = iCustom(NULL,0,"BrainTrend1StopLine",0,cnt+1);
   brain2 = iCustom(NULL,0,"BrainTrend1StopLine",1,cnt+1);
   bband1 = iCustom(NULL,0,"BBANDS~1",0,cnt+1);
   bband2 = iCustom(NULL,0,"BBANDS~1",1,cnt+1);
   if (brain2 == EMPTY_VALUE) {brain=brain1;}
   else {brain=brain2;}
   if (bband2 == EMPTY_VALUE) {bband=bband1;}
   else {bband=bband2;}
   
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,cnt+1) > weekly-buffer*Point || useweekly==false)
   {
    if(brain<Open[cnt+1] || usebrain==false)
    {
     if(bband<Open[cnt+1] || usebband==false)
     {
     entry=cnt;
     break;
    }}
   }
  }
 }
   
 //short 
 if(iMA(Symbol(),0,2,0,MAMode,pricemode,lastcross()) < daily+buffer*Point)
 {
  for(cnt=lastcross()-1;cnt>=0;cnt--)
  {
   brain1 = iCustom(NULL,0,"BrainTrend1StopLine",0,cnt+1);
   brain2 = iCustom(NULL,0,"BrainTrend1StopLine",1,cnt+1);
   bband1 = iCustom(NULL,0,"BBANDS~1",0,cnt+1);
   bband2 = iCustom(NULL,0,"BBANDS~1",1,cnt+1);
   if (brain2 == EMPTY_VALUE) {brain=brain1;}
   else {brain=brain2;}
   if (bband2 == EMPTY_VALUE) {bband=bband1;}
   else {bband=bband2;}
   
   if(iMA(Symbol(),0,2,0,MAMode,pricemode,cnt+1) < weekly-buffer*Point || useweekly==false)
   {
    if(brain>Open[cnt+1] || usebrain==false)
    {
     if(bband>Open[cnt+1] || usebband==false)
     {
      entry=cnt;
      break;
     }
    }
   }
  }
 }
 return(entry);
}


void modifystoploss()
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  
  
  
  //for long trades
  if(tradedirection()==1)
  {       
    if(SLA1 != 0 && Bid>= buyprice+SLA1*Point) {newsl=buyprice-SL1*Point;}
    if(SLA2 != 0 && Bid>= buyprice+SLA2*Point) {newsl=buyprice-SL2*Point;}
    if(SLA3 != 0 && Bid>= buyprice+SLA3*Point) {newsl=buyprice-SL3*Point;}
    if(SLA4 != 0 && Bid>= buyprice+SLA4*Point) {newsl=buyprice-SL4*Point;}
    if(SLA5 != 0 && Bid>= buyprice+SLA5*Point) {newsl=buyprice-SL5*Point;}
    
    // trail stop
    
    if(trailstop>0 && Bid>buyprice+trailstop*Point)
    {
     if(Bid-trailstop*Point>newsl) {newsl=Bid-trailstop*Point;}
    }
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(SLA1 != 0 && Ask<= buyprice-SLA1*Point) {newsl=buyprice+SL1*Point;}
    if(SLA2 != 0 && Ask<= buyprice-SLA2*Point) {newsl=buyprice+SL2*Point;}
    if(SLA3 != 0 && Ask<= buyprice-SLA3*Point) {newsl=buyprice+SL3*Point;}
    if(SLA4 != 0 && Ask<= buyprice-SLA4*Point) {newsl=buyprice+SL4*Point;}
    if(SLA5 != 0 && Ask<= buyprice-SLA5*Point) {newsl=buyprice+SL5*Point;}
    
    if(trailstop>0 && Ask<buyprice-trailstop*Point)
    {
     if(Ask+trailstop*Point<newsl) {newsl=Ask+trailstop*Point;}
    }
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
}


int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}


int endofday()
{
  int dayend=0; 
  if(Hour()==enday) {dayend=1;}
  if(DayOfWeek()==5 && Hour()==endayfriday) {dayend=1;}
  return(dayend);
}

void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<10;cnt++)
  {
    closetrades();
    if(opentrades()==0){cnt=10;}
  }
}  
  

void closetrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}

 
int tradedirection()
{

  int cnt;
  int direction;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
 
 

int openhour()
{
  int hours;
  
  if(Hour()< Start_time) {hours=24-Start_time+Hour();}
  else {hours=Hour()-Start_time;}
  
  return(hours);
}
  
int trades()
{
  int trades=0;
  
  if(TP1>0){trades ++;}
  if(TP2>0){trades ++;}
  if(TP3>0){trades ++;}
  if(TP4>0){trades ++;}
  if(TP5>0){trades ++;}
  
  
  return(trades);
}
  
  
int tradingtime()
{

  int trading=0;
  
  if(Start_time<endtradingtime && Hour()<endtradingtime && Hour()>Start_time) {trading=1;}
  if(Start_time>endtradingtime)
  {
    if(Hour()>Start_time) {trading=1;}
    if(Hour()<endtradingtime){trading=1;}
  }
  return(trading);
}
  